-- An example of using the enable/disable procedures.
without warning -- I don't use some stuff in this example, but that's OK
include ese.e -- Include ESE
-- Define the events
constant KEY_EVENT = AddEvent()     -- Define an event for when a key is pressed
constant QUIT_EVENT = AddEvent()    -- Define an event for when q is pressed
constant TIME_EVENT = AddEvent()    -- Define an event to be fired each second
atom starttime, lasttime
procedure KeyboardEventGenerator()  -- The keyboard event generator
    integer key
    key = get_key()
    if key != -1 then
	FireEvent(KEY_EVENT,{key})  -- Fire the event with one argument, key
    end if
end procedure
procedure TimeEventGenerator()
    if time()-lasttime >= 1 then
	FireEvent(TIME_EVENT,{time()-starttime})
	lasttime = time()
    end if
end procedure
constant TIME_EVENT_GENERATOR = AddEventGenerator(routine_id("TimeEventGenerator"))
procedure checkForQuit(integer key) -- Check for whether the user has pressed q
    if key = 'q' then
	FireEvent(QUIT_EVENT,{})    -- Fire the quit event, no arguments
    end if
end procedure
procedure checkForDisable(integer key)
    if key = 'd' then
	DisableEventGenerator(TIME_EVENT_GENERATOR)
    end if
end procedure
procedure checkForEnable(integer key)
    if key = 'e' then
	EnableEventGenerator(TIME_EVENT_GENERATOR)
    end if
end procedure
procedure onTimeEvent(atom tm)
    position(1,1)
    printf(1,"%d seconds since this program started",tm)
end procedure
procedure onQuitEvent()             -- When a quit event occurs
    StopEventLoop()                 -- Stop the loop
end procedure
-- Add the keyboard event generator
constant KEYEVENT_GENERATOR = AddEventGenerator(routine_id("KeyboardEventGenerator"))
-- Add the key event handler (to display the key code)
constant ONKEYEVENT = AddEventHandler(KEY_EVENT,routine_id("onKeyEvent"))
-- Add the key event handler (to check for 'q')
constant CHECKFORQUIT = AddEventHandler(KEY_EVENT,routine_id("checkForQuit"))
-- Add the quit event handler
constant ONQUITEVENT = AddEventHandler(QUIT_EVENT,routine_id("onQuitEvent"))
constant CHECKFORE = AddEventHandler(KEY_EVENT,routine_id("checkForEnable"))
constant CHECKFORD = AddEventHandler(KEY_EVENT,routine_id("checkForDisable"))
constant ONTICK = AddEventHandler(TIME_EVENT,routine_id("onTimeEvent"))
position(2,1)
puts(1,"Press q to quit.\nPress d to disable the timer.\n")
puts(1,"Press e to enable the timer.\n")
starttime = time()
lasttime = 0

StartEventLoop()
